Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encodings/RootParameterConfiguration.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encodings/RootParameterConfiguration.cs	(revision 4830)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encodings/RootParameterConfiguration.cs	(revision 4830)
@@ -0,0 +1,69 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.MetaOptimization {
+  /// <summary>
+  /// This class does not have a ParameterName, because its the root element of the ParameterConfiguration-Tree
+  /// It only deals with child-ParameterConfigurations
+  /// </summary>
+  [StorableClass]
+  public class RootParameterConfiguration : ParameterConfiguration {
+
+    public new IParameterizedNamedItem Value {
+      get { return (IParameterizedNamedItem)base.Value; }
+      set { base.Value = value; }
+    }
+
+    public RootParameterConfiguration(IParameterizedNamedItem rootItem) {
+      this.OptimizationEnabled = true;
+      this.Value = rootItem;
+    }
+
+    public RootParameterConfiguration() { }
+    [StorableConstructor]
+    protected RootParameterConfiguration(bool deserializing) { }
+    protected RootParameterConfiguration(RootParameterConfiguration original, Cloner cloner) : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RootParameterConfiguration(this, cloner);
+    }
+
+    public override IParameter Parameter {
+      get { return null; }
+    }
+
+    #region INamedItem Properties
+    public override string Name {
+      get { return Value.Name; }
+      set { throw new NotSupportedException(); }
+    }
+    public override string Description {
+      get { return Value.Description; }
+      set { throw new NotSupportedException(); }
+    }
+    public override bool CanChangeDescription {
+      get { return false; }
+    }
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    public override string ItemDescription {
+      get { return Value.ItemDescription; }
+    }
+    public override System.Drawing.Image ItemImage {
+      get { return Value.ItemImage; }
+    }
+    public override string ItemName {
+      get { return Value.ItemName; }
+    }
+    public override Version ItemVersion {
+      get { return Value.ItemVersion; }
+    }
+    #endregion
+  }
+}
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encodings/ValueTypeParameterConfiguration.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encodings/ValueTypeParameterConfiguration.cs	(revision 4830)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encodings/ValueTypeParameterConfiguration.cs	(revision 4830)
@@ -0,0 +1,80 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Data;
+using HeuristicLab.Core;
+using HeuristicLab.Collections;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.MetaOptimization {
+  [StorableClass]
+  public abstract class ValueTypeParameterConfiguration<T> : ParameterConfiguration where T : class, IItem, IStringConvertibleValue, IDeepCloneable {
+    [Storable]
+    private IItemList<IRange<T>> ranges;
+    public IItemList<IRange<T>> Ranges {
+      get { return ranges; }
+    }
+
+    public ValueTypeParameterConfiguration(ParameterConfiguration parentConfiguration, string parameterName, IItem value) : base(parentConfiguration, parameterName, value) {
+      this.ranges = new ItemList<IRange<T>>();
+      this.ranges.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<IRange<T>>>(ranges_ItemsAdded);
+      this.ranges.ItemsRemoved += new CollectionItemsChangedEventHandler<IndexedItem<IRange<T>>>(ranges_ItemsRemoved);
+      this.ranges.CollectionReset += new CollectionItemsChangedEventHandler<IndexedItem<IRange<T>>>(ranges_CollectionReset);
+    }
+
+    protected ValueTypeParameterConfiguration() { }
+    [StorableConstructor]
+    protected ValueTypeParameterConfiguration(bool deserializing) : base(deserializing) { }
+    protected ValueTypeParameterConfiguration(ValueTypeParameterConfiguration<T> original, Cloner cloner) : base(original, cloner) {
+      this.ranges = cloner.Clone(original.Ranges);
+    }
+
+    void ranges_CollectionReset(object sender, CollectionItemsChangedEventArgs<IndexedItem<IRange<T>>> e) {
+      foreach (var i in e.Items) {
+        DeregisterItemEvents(i.Value);
+      }
+      OnStringChanged(sender, e);
+    }
+
+    void ranges_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<IRange<T>>> e) {
+      foreach (var i in e.Items) {
+        DeregisterItemEvents(i.Value);
+      }
+      OnStringChanged(sender, e);
+    }
+
+    void ranges_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IRange<T>>> e) {
+      foreach (var i in e.Items) {
+        RegisterItemEvents(i.Value);
+      }
+      OnStringChanged(sender, e);
+    }
+
+    private void DeregisterItemEvents(IRange<T> range) {
+      range.ToStringChanged -= new EventHandler(range_ToStringChanged);
+    }
+    private void RegisterItemEvents(IRange<T> range) {
+      range.ToStringChanged += new EventHandler(range_ToStringChanged);
+    }
+
+    public IntValue GetRandomValue() {
+      return new IntValue(0);
+    }
+    
+    void range_ToStringChanged(object sender, EventArgs e) {
+      OnStringChanged(sender, e);
+    }
+
+    public override string ToString() {
+      return string.Format("{0}: ({1})", base.ToString(), string.Join(",", ranges.Select(r => r.ToString()).ToArray()));
+    }
+
+    //public override void SetRandomValue(IRandom random) {
+    //  int rangeIndex = random.Next(ranges.Count);
+    //  int value = random.Next(ranges.ElementAt(rangeIndex).LowerBound.Value, ranges.ElementAt(rangeIndex).UpperBound.Value); // TODO: respect StepSize parameter
+    //  this.Parameter.ActualValue = new IntValue(value);
+    //}
+  }
+}
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/MetaOptimizationEvaluator.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/MetaOptimizationEvaluator.cs	(revision 4539)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/MetaOptimizationEvaluator.cs	(revision 4830)
@@ -10,4 +10,5 @@
 using HeuristicLab.Optimization;
 using System.Threading;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Problems.MetaOptimization {
@@ -18,4 +19,6 @@
   [StorableClass]
   public class MetaOptimizationEvaluator : SingleSuccessorOperator, IMetaOptimizationEvaluator {
+    private const string RepetitionsParameterName = "Repetitions";
+
     private bool algorithmStopped;
 
@@ -23,30 +26,62 @@
       get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
-
     public ILookupParameter<IAlgorithm> AlgorithmParameter {
       get { return (ILookupParameter<IAlgorithm>)Parameters["Algorithm"]; }
     }
-    public ILookupParameter<IParameterSet> ParameterSetParameter {
-      get { return (ILookupParameter<IParameterSet>)Parameters["ParameterSet"]; }
+    public ILookupParameter<IItemList<IProblem>> ProblemsParameter {
+      get { return (ILookupParameter<IItemList<IProblem>>)Parameters["Problems"]; }
+    }
+    public ILookupParameter<IParameterConfiguration> ParameterConfigurationParameter {
+      get { return (ILookupParameter<IParameterConfiguration>)Parameters["ParameterConfiguration"]; }
+    }
+    public ValueParameter<IntValue> RepetitionsParameter {
+      get { return (ValueParameter<IntValue>)Parameters[RepetitionsParameterName]; }
     }
 
-    public MetaOptimizationEvaluator()
-      : base() {
-      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The evaluated quality of the TSP solution."));
+    public IntValue Repetitions {
+      get { return RepetitionsParameter.Value; }
+      set { RepetitionsParameter.Value = value; }
+    }
+
+    public MetaOptimizationEvaluator() : base() {
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The evaluated quality of the ParameterVector."));
       Parameters.Add(new LookupParameter<IAlgorithm>("Algorithm", "Missing description."));
-      Parameters.Add(new LookupParameter<IParameterSet>("ParameterSet", "Missing description."));
+      Parameters.Add(new LookupParameter<IItemList<IProblem>>("Problems", "Missing description."));
+      Parameters.Add(new LookupParameter<IParameterConfiguration>("ParameterConfiguration", "Missing description."));
+      Parameters.Add(new ValueParameter<IntValue>(RepetitionsParameterName, "Number of evaluations for one individual.", new IntValue(3)));
+    }
+
+    [StorableConstructor]
+    protected MetaOptimizationEvaluator(bool deserializing) : base(deserializing) { }
+    protected MetaOptimizationEvaluator(MetaOptimizationEvaluator original, Cloner cloner)
+      : base(original, cloner) {
+      this.algorithmStopped = original.algorithmStopped;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MetaOptimizationEvaluator(this, cloner);
     }
 
     public override IOperation Apply() {
       AlgorithmParameter.ActualValue.Prepare();
-      ParametrizeAlgorithm();
+      //ParameterizeAlgorithm();
+      ParameterConfigurationParameter.ActualValue.Parameterize(AlgorithmParameter.ActualValue);
       algorithmStopped = false;
       AlgorithmParameter.ActualValue.Stopped += new EventHandler(ActualValue_Stopped);
-      AlgorithmParameter.ActualValue.Start();
-      while (!algorithmStopped) {
-        Thread.Sleep(1000); // wait for algorithm to complete; do not rely on Algorithm.ExecutionState here, because change of ExecutionState happens before Run is added (which causes problems because Algorithm might get cloned when its started already)
+
+      double qualitySum = 0;
+
+      foreach (IProblem problem in ProblemsParameter.ActualValue) {
+        AlgorithmParameter.ActualValue.Problem = problem;
+        AlgorithmParameter.ActualValue.Start();
+        while (!algorithmStopped) {
+          Thread.Sleep(1000); // wait for algorithm to complete; do not rely on Algorithm.ExecutionState here, because change of ExecutionState happens before Run is added (which causes problems because Algorithm might get cloned when its started already)
+        }
+        AlgorithmParameter.ActualValue.Stopped -= new EventHandler(ActualValue_Stopped);
+        qualitySum += ((DoubleValue)AlgorithmParameter.ActualValue.Results["BestQuality"].Value).Value;
       }
-      AlgorithmParameter.ActualValue.Stopped -= new EventHandler(ActualValue_Stopped);
-      this.QualityParameter.ActualValue = (DoubleValue)AlgorithmParameter.ActualValue.Results["BestQuality"].Value;
+
+      double qualityAvg = qualitySum / ProblemsParameter.ActualValue.Count;
+      this.QualityParameter.ActualValue = new DoubleValue(qualityAvg);
+
       return base.Apply();
     }
@@ -56,13 +91,13 @@
     }
 
-    private void ParametrizeAlgorithm() {
-      foreach (IParameterConfiguration parameter in ParameterSetParameter.ActualValue.Parameters) {
-        if (parameter.Category == "Algorithm") {
-          this.AlgorithmParameter.ActualValue.Parameters[parameter.Parameter.Name].ActualValue = parameter.Parameter.ActualValue;
-        } else if (parameter.Category == "Problem") {
-          this.AlgorithmParameter.ActualValue.Problem.Parameters[parameter.Parameter.Name].ActualValue = parameter.Parameter.ActualValue;
-        }
-      }
-    }
+    //private void ParameterizeAlgorithm() {
+    //  foreach (IParameterConfiguration parameter in ParameterVectorParameter.ActualValue) {
+    //    if (typeof(IAlgorithm).IsAssignableFrom(parameter.OperatorType)) {
+    //      this.AlgorithmParameter.ActualValue.Parameters[parameter.Parameter.Name].ActualValue = parameter.Parameter.ActualValue;
+    //    } else if (typeof(IProblem).IsAssignableFrom(parameter.OperatorType)) {
+    //      this.AlgorithmParameter.ActualValue.Problem.Parameters[parameter.Parameter.Name].ActualValue = parameter.Parameter.ActualValue;
+    //    }
+    //  }
+    //}
   }
 }
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/HeuristicLab.Problems.MetaOptimization-3.3.csproj
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/HeuristicLab.Problems.MetaOptimization-3.3.csproj	(revision 4539)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/HeuristicLab.Problems.MetaOptimization-3.3.csproj	(revision 4830)
@@ -88,21 +88,19 @@
   <ItemGroup>
     <Compile Include="Analyzers\BestQualityAnalyzer.cs" />
-    <Compile Include="Creators\RandomParameterSetCreator.cs" />
-    <Compile Include="Encodings\BooleanParameterConfiguration.cs" />
-    <Compile Include="Encodings\Crossovers\ParameterSetCrossover.cs" />
-    <Compile Include="Interfaces\IParameterSetOperator.cs" />
-    <Compile Include="NumericRangeList.cs" />
-    <Compile Include="Encodings\EnumerableParameterConfiguration.cs" />
-    <Compile Include="Interfaces\INumericRange.cs" />
-    <Compile Include="Encodings\NumericParameterConfiguration.cs" />
-    <Compile Include="Encodings\ParameterSet.cs" />
+    <Compile Include="Interfaces\IParameterConfigurationCreator.cs" />
+    <Compile Include="Creators\RandomParameterConfigurationCreator.cs" />
+    <Compile Include="Encodings\Crossovers\ParameterVectorCrossover.cs" />
+    <Compile Include="Encodings\IntValueParameterConfiguration.cs" />
+    <Compile Include="Encodings\ValueTypeParameterConfiguration.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Encodings\RootParameterConfiguration.cs" />
+    <Compile Include="Interfaces\IParameterConfigurationOperator.cs" />
+    <Compile Include="Interfaces\IRange.cs" />
     <Compile Include="Evaluators\MetaOptimizationEvaluator.cs" />
     <Compile Include="Interfaces\IMetaOptimizationEvaluator.cs" />
-    <Compile Include="Interfaces\IParameterSet.cs" />
-    <Compile Include="Interfaces\IParameterSetCreator.cs" />
     <Compile Include="Interfaces\IParameterConfiguration.cs" />
     <Compile Include="Encodings\ParameterConfiguration.cs" />
-    <Compile Include="Encodings\ParameterConfigurationList.cs" />
-    <Compile Include="NumericRange.cs" />
+    <Compile Include="Range.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="MetaOptimizationProblem.cs" />
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IParameterConfiguration.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IParameterConfiguration.cs	(revision 4539)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IParameterConfiguration.cs	(revision 4830)
@@ -7,8 +7,15 @@
 namespace HeuristicLab.Problems.MetaOptimization {
   public interface IParameterConfiguration : INamedItem {
-    IParameter Parameter { get; set; }
-    string Category { get; set; }
+    bool OptimizationEnabled { get; set; }
+    string ParameterName { get; set; }
+    IParameter Parameter { get; }
+    IItem Value { get; set; }
+    IItemList<IParameterConfiguration> ChildParameterConfigurations { get; }
 
-    void SetParameterWithRandomValue(IRandom random);
+    void Parameterize(IParameterizedItem parameterizedItem);
+
+    event EventHandler OptimizationEnabledChanged;
+    event EventHandler ValueChanging;
+    event EventHandler ValueChanged;
   }
 }
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IParameterConfigurationCreator.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IParameterConfigurationCreator.cs	(revision 4830)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IParameterConfigurationCreator.cs	(revision 4830)
@@ -0,0 +1,10 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.MetaOptimization {
+  public interface IParameterConfigurationCreator : ISolutionCreator {
+  }
+}
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IParameterConfigurationOperator.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IParameterConfigurationOperator.cs	(revision 4830)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IParameterConfigurationOperator.cs	(revision 4830)
@@ -0,0 +1,12 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.MetaOptimization {
+  /// <summary>
+  /// An interface which represents an operator dealing with parameter sets.
+  /// </summary>
+  public interface IParameterConfigurationOperator : IOperator { }
+}
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IRange.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IRange.cs	(revision 4830)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IRange.cs	(revision 4830)
@@ -0,0 +1,19 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Data;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.MetaOptimization {
+  public interface IRange<T> : IItem where T : class, IItem, IStringConvertibleValue, IDeepCloneable {
+    T LowerBound { get; set; }
+    T UpperBound { get; set; }
+    T StepSize { get; set; }
+
+    event EventHandler LowerBoundChanged;
+    event EventHandler UpperBoundChanged;
+    event EventHandler StepSizeChanged;
+  }
+}
